package com.miqporta.cloc.clocWS.DAO;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Restrictions;

import com.miqporta.cloc.clocWS.model.Pelicula;
import com.miqporta.cloc.common.HibernateUtil;

public class PeliculaDAO {
	
	public void addPelicula(Pelicula pelicula){
		Session session = null;
		try{
			session = openSession(session); 
			
			session.saveOrUpdate(pelicula);

			session.getTransaction().commit();

		}catch (Exception e) {
			controlSession( session,  e);
		}
		finally{
			closeSession(session);
		}
	}
	
	public Pelicula findByTitulo(String titulo){
		
		Session session = null;
		Pelicula pelicula = null;
		
		try{
			session = openSession(session); 
			
			Criteria criteria =  session.createCriteria(Pelicula.class);
			
			Criterion c1  = Restrictions.ilike("tituloVO", "%"+titulo+"%");
			Criterion c2  = Restrictions.ilike("tituloESP", "%"+titulo+"%");
			criteria.add(Restrictions.or(c1, c2));
			
			
			List<Pelicula> peliculaList = (List<Pelicula>) criteria.list();
			if(!peliculaList.isEmpty()){
				pelicula = peliculaList.get(0);
			}
			
			session.getTransaction().commit();
			
		}catch (Exception e) {
			controlSession( session,  e);
		}
		finally{
			closeSession(session);
		}
		return pelicula;

	}
	
	public Pelicula findByExactTitulo(String titulo) {
		Session session = null;
		Pelicula pelicula = null;
		
		try{
			session = openSession(session); 
			
			Criteria criteria =  session.createCriteria(Pelicula.class);
			
			Criterion c1  = Restrictions.ilike("tituloVO", titulo);
			Criterion c2  = Restrictions.ilike("tituloESP", titulo);
			criteria.add(Restrictions.or(c1, c2));
			
			
			List<Pelicula> peliculaList = (List<Pelicula>) criteria.list();
			if(!peliculaList.isEmpty()){
				pelicula = peliculaList.get(0);
			}
			
			session.getTransaction().commit();
			
		}catch (Exception e) {
			controlSession( session,  e);
		}
		finally{
			closeSession(session);
		}
		return pelicula;

	}
	
	
	public Pelicula findById(long peliculaId){
		
		Session session = null;
		Pelicula pelicula = new Pelicula();
		try{
			session = openSession(session); 
			
			Criteria criteria =  session.createCriteria(Pelicula.class);
			
			criteria.add(Restrictions.eq("peliculaId", peliculaId));
			
			List<Pelicula> peliculaList = (List<Pelicula>) criteria.list();
			if(!peliculaList.isEmpty()){
				pelicula = peliculaList.get(0);
			}
			
			session.getTransaction().commit();
			
		}catch (Exception e) {
			controlSession( session,  e);
		}
		finally{
			closeSession(session);
		}
		return pelicula;
	}
	
public List<Pelicula> findAll(){
		
		Session session = null;
		List<Pelicula> peliculaList = new ArrayList<Pelicula>();
		try{
			session = openSession(session); 
			
			Criteria criteria =  session.createCriteria(Pelicula.class);
			
			peliculaList = (List<Pelicula>) criteria.list();
						
			session.getTransaction().commit();
			
		}catch (Exception e) {
			controlSession( session,  e);
		}
		finally{
			closeSession(session);
		}
		return peliculaList;
	}
	
	private Session openSession(Session session){
		session = HibernateUtil.getSessionFactory().openSession();		
		session.beginTransaction(); 
		
		return session;
	}
	
	private void controlSession(Session session, Exception e){
		try{
			session.getTransaction().rollback();
		}catch(Exception ex){
			ex.printStackTrace();
		}
		e.printStackTrace();
	}
	
	private void closeSession(Session session){
		if(session!=null){
			session.close();
		}
	}
	
}
