package com.miqporta.cloc.clocWS.controller;

import java.util.List;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.json.JSONArray;
import org.json.JSONObject;

import com.miqporta.cloc.clocWS.BO.EscenaBO;
import com.miqporta.cloc.clocWS.modelVO.LocalizacionDetalleVO;
import com.miqporta.cloc.clocWS.modelVO.LocalizacionMapaVO;

@Path("/rest")
public class ClocController {
	
	@GET
	@Path("/buscarPorUbicacion/{latitud}/{longitud}")
	@Produces("application/json")
	public Response buscarPorUbicacion(@PathParam("latitud")String latitud
										,@PathParam("longitud") String longitud){
	
		EscenaBO escenaBO = new EscenaBO();
		
		List<LocalizacionMapaVO> localizacionesMapaList = 
								escenaBO.findByUbicacionYDistancia(latitud.replace(",", "."), 
																	longitud.replace(",", "."), 1);
		if(localizacionesMapaList.isEmpty()){
			localizacionesMapaList = 
					escenaBO.findByUbicacionYDistancia(latitud.replace(",", "."), 
														longitud.replace(",", "."), 3);
		}
		
		if(localizacionesMapaList.isEmpty()){
			localizacionesMapaList = 
					escenaBO.findByUbicacionYDistancia(latitud.replace(",", "."), 
														longitud.replace(",", "."), 10);
		}
		
		
		
		JSONObject jsonFinal = new JSONObject();
		JSONArray  jsonArrayLocalizacionMapa = new JSONArray();
		String result ="";
		for(LocalizacionMapaVO localizacionMapaVO : localizacionesMapaList){
			JSONObject jsonLocalizacionMapa = new JSONObject();
			jsonLocalizacionMapa.put("escenaId", localizacionMapaVO.getEscenaId());
			jsonLocalizacionMapa.put("tituloVO", localizacionMapaVO.getTituloVO());
			jsonLocalizacionMapa.put("latitud", localizacionMapaVO.getLatitud());
			jsonLocalizacionMapa.put("longitud", localizacionMapaVO.getLongitud());
			jsonArrayLocalizacionMapa.put(jsonLocalizacionMapa);
		}
		jsonFinal.put("localizaciones", jsonArrayLocalizacionMapa);
		result = jsonFinal.toString();
		return Response.status(200).entity(result).build(); 
	}
	
	@GET
	@Path("/buscarPorTitulo/{titulo}")
	@Produces("application/json")
	public Response buscarPorTitulo(@PathParam("titulo")String titulo){
	
		EscenaBO escenaBO = new EscenaBO();
		
		List<LocalizacionMapaVO> localizacionesMapaList = escenaBO.findEscenasByTitulo(titulo);
		
		
		JSONObject jsonFinal = new JSONObject();
		JSONArray  jsonArrayLocalizacionMapa = new JSONArray();
		String result ="";
		for(LocalizacionMapaVO localizacionMapaVO : localizacionesMapaList){
			JSONObject jsonLocalizacionMapa = new JSONObject();
			jsonLocalizacionMapa.put("escenaId", localizacionMapaVO.getEscenaId());
			jsonLocalizacionMapa.put("tituloVO", localizacionMapaVO.getTituloVO());
			jsonLocalizacionMapa.put("latitud", localizacionMapaVO.getLatitud());
			jsonLocalizacionMapa.put("longitud", localizacionMapaVO.getLongitud());
			jsonArrayLocalizacionMapa.put(jsonLocalizacionMapa);
		}
		jsonFinal.put("localizaciones", jsonArrayLocalizacionMapa);
		result = jsonFinal.toString();
		
		return Response.status(200).entity(result).build(); 
	}
	
	@GET
	@Path("/buscarPorEscena/{escenaId}")
	@Produces("application/json")
	public Response buscarPorEscena(@PathParam("escenaId")String escenaId){
	
		EscenaBO escenaBO = new EscenaBO();
		
		LocalizacionDetalleVO localizacionDetalle = escenaBO.findEscenasByEscenaId(escenaId);
		
		JSONObject jsonlocalizacionDetalle = new JSONObject();
		JSONObject jsonFinal = new JSONObject();
		JSONArray  jsonArrayLocalizacionDetalle = new JSONArray();
		String result ="";
		
		jsonlocalizacionDetalle.put("tituloVO", localizacionDetalle.getTituloVO());
		jsonlocalizacionDetalle.put("tituloESP", localizacionDetalle.getTituloESP());	
		jsonlocalizacionDetalle.put("anyo", localizacionDetalle.getAnyo());
		jsonlocalizacionDetalle.put("diretor", localizacionDetalle.getDirector());
		jsonlocalizacionDetalle.put("escenaDetalleVO", localizacionDetalle.getEscenaDetalleList());
		jsonArrayLocalizacionDetalle.put(jsonlocalizacionDetalle);
		jsonFinal.put("localizacionDetalle", jsonArrayLocalizacionDetalle);
		
		result+= jsonFinal;
		
		return Response.status(200).entity(result).build(); 
	}
	
	@POST
	@Path("/anadirLocalizacion")
	@Consumes(MediaType.APPLICATION_JSON)
	public Response anadirLocalizacion(LocalizacionDetalleVO localizacionDetalleVO){
		
		String result = "localizacionDetalle created : " + localizacionDetalleVO;
		EscenaBO escenaBO = new EscenaBO();
		
		escenaBO.anadirUbicacion(localizacionDetalleVO);
		
		return Response.status(201).entity(result).build();
	}
}
