package com.miqporta.cloc.clocWS.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name = "ESCENA")
public class Escena implements Serializable {

	private static final long serialVersionUID = 607199239590527936L;

	private long escenaId;
	private Pelicula pelicula;
	private Date dataAlta;
	private Date dataBaja;
	private String descripcion;
	private double latitud;
	private double longitud;
	private String captura;
	/*ESCENA_ID int NOT NULL AUTO_INCREMENT,
	  PELICULA_ID int NOT NULL,
	  DATA_ALTA TIMESTAMP NOT NULL,
	  DATA_BAJA TIMESTAMP,
	  DESCRIPCION varchar(255),
	  LATITUD Double(11,7),
	  LONGITUD Double(11,7),
	  CAPTURA varchar(120), */
	
	public Escena(){
	}
	public Escena(long escenaId, Pelicula pelicula, Date dataAlta, 
			Date dataBaja, String descripcion, double latitud,
			double longitud, String captura) {
		this.pelicula = pelicula;
		this.dataAlta = dataAlta;
		this.dataBaja = dataBaja;
		this.descripcion = descripcion;
		this.latitud = latitud;
		this.longitud = longitud;
		this.captura = captura;
	}
	public Escena(Pelicula pelicula, Date dataAlta, 
			Date dataBaja, String descripcion, double latitud,
			double longitud, String captura) {
		this.pelicula = pelicula;
		this.dataAlta = dataAlta;
		this.dataBaja = dataBaja;
		this.descripcion = descripcion;
		this.latitud = latitud;
		this.longitud = longitud;
		this.captura = captura;
	}
	
	@Id
	@GeneratedValue(strategy=GenerationType.AUTO)  
	@Column(name="ESCENA_ID", unique = true, 
			nullable = false, precision = 6, scale = 0)
	public long getEscenaId() {
		return escenaId;
	}

	public void setEscenaId(long escenaId) {
		this.escenaId = escenaId;
	}
	
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "PELICULA_ID", nullable = false)
	public Pelicula getPelicula() {
		return pelicula;
	}

	public void setPelicula(Pelicula pelicula) {
		this.pelicula = pelicula;
	}
	
	@Temporal(TemporalType.DATE)
	@Column(name="DATA_ALTA", nullable = false)
	public Date getDataAlta() {
		return dataAlta;
	}

	public void setDataAlta(Date dataAlta) {
		this.dataAlta = dataAlta;
	}
	
	@Temporal(TemporalType.DATE)
	@Column(name="DATA_BAJA", nullable = true)
	public Date getDataBaja() {
		return dataBaja;
	}

	public void setDataBaja(Date dataBaja) {
		this.dataBaja = dataBaja;
	}
	
	@Column(name="DESCRIPCION", nullable = true, length = 255)
	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public double getLatitud() {
		return latitud;
	}

	public void setLatitud(double latitud) {
		this.latitud = latitud;
	}

	public double getLongitud() {
		return longitud;
	}

	public void setLongitud(double longitud) {
		this.longitud = longitud;
	}
	
	@Column(name="CAPTURA", nullable = true, length = 120)
	public String getCaptura() {
		return captura;
	}

	public void setCaptura(String captura) {
		this.captura = captura;
	}
	
}
