package com.miqporta.cloc.clocWS.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;

@Entity
@Table(name = "PELICULA")
public class Pelicula implements Serializable{
	
	private static final long serialVersionUID = -7434379013994659142L;
	
	private long peliculaId;
	private Date dataAlta;
	private Date dataBaja;
	private String anyo;
	private String tituloVO;
	private String tituloESP;
	private String director;
	/*PELICULA_ID int NOT NULL AUTO_INCREMENT,
	  DATA_ALTA TIMESTAMP NOT NULL,
	  DATA_BAJA TIMESTAMP,
	  ANYO varchar(4),
	  TITULO_VO varchar(120) NOT NULL,
	  TITULO_ESP varchar(120),
	  DIRECTOR varchar(120), */
	public Pelicula(){
	}
	
	public Pelicula(Long peliculaId, Date dataAlta, Date dataBaja, String anyo, 
			String tituloVO, String tituloESP,	String director) {
		this.dataAlta = dataAlta;
		this.dataBaja = dataBaja;
		this.anyo = anyo;
		this.tituloVO = tituloVO;
		this.tituloESP = tituloESP;
		this.director = director;
	}
	public Pelicula(Date dataAlta, Date dataBaja, String anyo, 
			String tituloVO, String tituloESP,	String director) {
		this.dataAlta = dataAlta;
		this.dataBaja = dataBaja;
		this.anyo = anyo;
		this.tituloVO = tituloVO;
		this.tituloESP = tituloESP;
		this.director = director;
	}
	
	@Id
	@GeneratedValue(strategy=GenerationType.AUTO)  
	@Column(name="PELICULA_ID", unique = true, 
			nullable = false, precision = 6, scale = 0)
	public long getPeliculaId() {
		return peliculaId;
	}
	public void setPeliculaId(long peliculaId) {
		this.peliculaId = peliculaId;
	}
	
	@Temporal(TemporalType.DATE)
	@Column(name="DATA_ALTA", nullable = false)
	public Date getDataAlta() {
		return dataAlta;
	}
	public void setDataAlta(Date dataAlta) {
		this.dataAlta = dataAlta;
	}
	
	@Temporal(TemporalType.DATE)
	@Column(name="DATA_BAJA", nullable = true)
	public Date getDataBaja() {
		return dataBaja;
	}
	public void setDataBaja(Date dataBaja) {
		this.dataBaja = dataBaja;
	}
	
	@Column(name="ANYO", nullable = true, length = 4)
	public String getAnyo() {
		return anyo;
	}
	public void setAnyo(String anyo) {
		this.anyo = anyo;
	}
	
	@Column(name="TITULO_VO", nullable = false, length = 120)
	public String getTituloVO() {
		return tituloVO;
	}
	public void setTituloVO(String tituloVO) {
		this.tituloVO = tituloVO;
	}
	
	@Column(name="TITULO_ESP", nullable = true, length = 120)
	public String getTituloESP() {
		return tituloESP;
	}
	public void setTituloESP(String tituloESP) {
		this.tituloESP = tituloESP;
	}
	
	@Column(name="DIRECTOR", nullable = true, length = 120)
	public String getDirector() {
		return director;
	}
	public void setDirector(String director) {
		this.director = director;
	}
	
}
